// ==UserScript==
// @name          ImageShrinker v0.1
// @description	  Resizes large images so that they don't cause horizontal scrolling.
// @include       http://www.genmay.net/*
// @include       http://www.genmay.com/*
// @include       http://genmay.net/*
// @include       http://genmay.com/*
// @exclude       
// ==/UserScript==

function imageshrinker(e) {
	var doc = e.originalTarget;

	img_max_width = mayhemex.script_settings.getIntPref("imageshrinker.max_width");

	function delayed_resize(img, index){
		if(parseInt(img.width) == 0){
			timeoutID = content.window.setTimeout(delayed_resize, 1000, img, index);
		}else{
			resize_image(img, index);
		}
	}


	function resize_image(img, index){
		if(parseInt(img.width) > img_max_width){
			ran_num = Math.floor(Math.random()*1000);
			original_width[index] = parseInt(img.width);
			label_pos = img.offsetTop-20;

			label = doc.createElement("div");
			label.setAttribute("style", "vertical-align:middle; padding:2px; font-family:verdana; font-size:7pt; background:#333; border:1px solid #999; position:absolute; top:"+label_pos);
			label.innerHTML = "This image has been resized";
			img.parentNode.insertBefore(label, img);

			img.addEventListener('click', function (e){
				e.target.width = (parseInt(e.target.width) == original_width[index]) ? img_max_width:original_width[index];
			}, false);

			img.width = img_max_width;

			img.style.border = "1px solid #999";
		}
	}


	imgs = doc.evaluate(
		"//img",
		doc,
		null,
		XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,
		null);

	var original_width = new Array(imgs.snapshotLength);

	for(var i = 0; i < imgs.snapshotLength; i++) {
		if(imgs.snapshotItem(i).src.match(/genmay/)){
			continue;
		}

		if(parseInt(imgs.snapshotItem(i).width) == 0 || parseInt(imgs.snapshotItem(i).height)){
			not_loaded = imgs.snapshotItem(i);
			timeoutID = content.window.setTimeout(delayed_resize, 1000, imgs.snapshotItem(i), i);
			continue;
		}
	
		resize_image(imgs.snapshotItem(i), i);
	}

}