// ==UserScript==
// @name          Original Titles
// @description	  Attempts to change the threadtitle to what it was before it was titleraped
// @include       http://www.genmay.net/*
// @include       http://www.genmay.com/*
// @include       http://www.genmay.org/*
// @include       http://genmay.net/*
// @include       http://genmay.com/*
// @include       http://genmay.org/*
// @exclude       http://genmay.theintarweb.net/*
// ==/UserScript==


// Holds string which becomes the array of titles
var originaltitles_data;

var originaltitles_update_timer = 0;

/* =================================================================== *\
   Initiate originaltitles updates
\* =================================================================== */
function originaltitles_init(){
	const id = "mayhemex@theintarweb.net";

	var originaltitles_data_file = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(id)
					.getItemLocation(id); 
	originaltitles_data_file.append("originaltitles_data.txt");
	
	if(!originaltitles_data_file.exists()){
		originaltitles_grab_update();
		return;
	}
	
	var charset = "UTF-8";
	const replacementChar = Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER;
	var fis = Components.classes["@mozilla.org/network/file-input-stream;1"]
			.createInstance(Components.interfaces.nsIFileInputStream);
	fis.init(originaltitles_data_file, 1, 0, false);



	var is = Components.classes["@mozilla.org/intl/converter-input-stream;1"]
			.createInstance(Components.interfaces.nsIConverterInputStream);
	is.init(fis, charset, 1024, replacementChar);

	var str = {};
	originaltitles_data = "";
	while (is.readString(4096, str) != 0) {
		originaltitles_data += str.value;

	}
}


/* =================================================================== *\
   Grap originaltitles update
\* =================================================================== */
function originaltitles_grab_update(){
	log("originaltitles: grabbing update");
	mayhemex.fetch_url('http://mayhemex.theintarweb.net/grab_latest_titles.php?v='+mayhemex.version, 'originaltitles_update');
}


/* =================================================================== *\
   Run originaltitles update
\* =================================================================== */
function originaltitles_update(str){

	var update_arr = str.split("\n");

	// Just the date of the latest update has been fetched
	if(update_arr.length < 3){
		var latest_update = mayhemex.script_settings.getCharPref("originaltitles.latest_update");
		var current_version = update_arr[0];

		// update not needed
		if(latest_update == current_version){
			return;
		// fetch update
		}else{
			mayhemex.fetch_url('http://mayhemex.theintarweb.net/grab_latest_titles.php?full_list=1&v='+mayhemex.version, 'originaltitles_update');
			return;
		}

	// Full list has been fetched, write new list to file and all that good stuff
	}else{
		try{
			var current_version = update_arr[0];
			update_arr.shift();
			var update_data = update_arr.join("\n");

			const id = "mayhemex@theintarweb.net";
			var originaltitles_data_file = Components.classes["@mozilla.org/extensions/manager;1"]
							.getService(Components.interfaces.nsIExtensionManager)
							.getInstallLocation(id)
							.getItemLocation(id); 
			originaltitles_data_file.append("originaltitles_data.txt");

			var fos = Components.classes["@mozilla.org/network/file-output-stream;1"]
								 .createInstance(Components.interfaces.nsIFileOutputStream);
			fos.init(originaltitles_data_file, 0x02 | 0x08 | 0x20, 0664, 0);
			
			var charset = "UTF-8"; // Can be any character encoding name that Mozilla supports
			var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"]
						   .createInstance(Components.interfaces.nsIConverterOutputStream);
			os.init(fos, charset, 4096, 0x0000);

			os.writeString(update_data);
			
			os.close();
			fos.close();

			mayhemex.script_settings.setCharPref("originaltitles.latest_update", current_version);

			originaltitles_init();
		}
		catch(err){
			alert("Something went wrong when trying to write the originaltitles update to file:\n\n"+err.description);
		}
	}
}

function originaltitles(e){
	var doc = e.originalTarget;

	// Time for an update?
	stamp = new Date();
	current_minute = stamp.getMinutes().toString();

	var latest_check = mayhemex.script_settings.getIntPref("originaltitles.latest_check");
	diff = current_minute - latest_check;
	if(diff > 10 || diff < -10){
		originaltitles_grab_update();
		mayhemex.script_settings.setIntPref("originaltitles.latest_check", current_minute);
	}
	

	// get on with it
	eval(unescape(originaltitles_data));


	if(threads.length < 1){
		return;
	}

	// Silly workaround since JavaScript have a redicolusly limited
	// set of string functions. We stick the value of threads[id] into
	// the textarea and then use the innerHTML value of this textarea
	// when comparing to the current title. That way "&quot;" and such
	// strings get converted to their ascii equivs.
	var hidden_converter = doc.createElement("textarea");
	hidden_converter.setAttribute("style", "display:none;");

	var body = doc.getElementsByTagName('body')[0];
	body.appendChild(hidden_converter);


	var thread_links, id, original_title;
	var original_titles = new Array();
	thread_links = doc.evaluate(
		"//a[contains(@id, 'thread_title_')]",
		doc,
		null,
		XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,
		null);
	for(var i = 0; i < thread_links.snapshotLength; i++) {

		id = thread_links.snapshotItem(i).getAttribute("id");
		id = id.replace("thread_title_", "");
		title_element = thread_links.snapshotItem(i);
		current_title = thread_links.snapshotItem(i).innerHTML;

		hidden_converter.innerHTML = threads[id];

		if(current_title != hidden_converter.innerHTML && threads[id] != undefined){
			title_element.setAttribute("title", title_element.innerHTML);
			title_element.setAttribute("style", "color:#ffcc33;");
			title_element.innerHTML = threads[id];
		}
	}
}

function originaltitles_init_updater(){
	window.setInterval(function(e) {originaltitles_grab_update();}, (60*5*1000));
}

window.addEventListener("load", function(e) { originaltitles_init(e); }, false);
//window.addEventListener("load", function(e) { originaltitles_init_updater(e); }, false);