/* =================================================================== *\
   If you use my code for your own projects the least you can do is
   give me some credit for it by linking to where you got this from.
\* =================================================================== */


var mayhemex = {
	/* =================================================================== *\
	   Startup function
	\* =================================================================== */
	init: function() {
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
				.getService(Components.interfaces.nsIPrefService)
				.getBranch("extensions.mayhemex");
		this.prefs.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.prefs.addObserver("", this, false);

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefBranch);
		this.main_settings = prefs.getBranch("extensions.mayhemex.");
		this.script_settings = prefs.getBranch("extensions.mayhemex.scripts.");

		this.version = this.main_settings.getCharPref("version");
		this.uploaderx_details_url = "";
		mayhemex.get_settings();
		mayhemex.phone_home();
		mayhemex.toggle_grintard();
	},

	
	/* =================================================================== *\
	   Shows or hides the grintard depending on... wether or not it should
	   be, you know, visible.
	\* =================================================================== */
	toggle_grintard: function(){
		var visibility = (mayhemex.grintard === false) ? "display:none;":"display:;";
		document.getElementById('mayhemex_status_bar').setAttribute("style", visibility);
	},

	/* =================================================================== *\
	   Clean up... I need a maid.
	\* =================================================================== */
	shutdown: function()
	{
		this.prefs.removeObserver("", this);
	},
	
	/* =================================================================== *\
	   Called when events occur on the preferences
	\* =================================================================== */
	observe: function(subject, topic, data)
	{
		if (topic != "nsPref:changed")
		{
			return;
		}
		mayhemex.get_settings();
		mayhemex.toggle_grintard();
	},


	/* =================================================================== *\
	   Init context menu entry
	\* =================================================================== */
	init_context_menu: function (){
		var menu = document.getElementById("contentAreaContextMenu");
		menu.addEventListener("popupshowing", mayhemex.context_showing, false);
	},

/*
4309     this.onTextInput       = false;
4310     this.onKeywordField    = false;
4311     this.onImage           = false;
4312     this.onLoadedImage     = false;
4313     this.onLink            = false;
4314     this.onMailtoLink      = false;
4315     this.onSaveableLink    = false;
4316     this.onMetaDataItem    = false;
4317     this.onMathML          = false;
4318     this.link              = false;
4319     this.linkURL           = "";
4320     this.linkURI           = null;
4321     this.linkProtocol      = null;
4322     this.inFrame           = false;
4323     this.hasBGImage        = false;
4324     this.isTextSelected    = false;
4325     this.isContentSelected = false;
4326     this.inDirList         = false;
4327     this.shouldDisplay     = true;
4328     this.isDesignMode      = false;
4329     this.possibleSpellChecking = false;
*/

	/* =================================================================== *\
	   Add menu items when context menu is showing
	\* =================================================================== */
	context_showing: function (event){
		var img_src = "";
		var is_uploaderx = false;

		if(gContextMenu.onImage){
			img_src = gContextMenu.imageURL;

			if(img_src.indexOf('uploaderx.net') > 0 && mayhemex.enabled_scripts_named["uploaderxdetails"] == 1){
				is_uploaderx = true;
				mayhemex.uploaderx_details_url = img_src.replace(/\/x\//, "/x/details/");
			}
		}
		gContextMenu.showItem("mayhemex_uploaderx_details", is_uploaderx);
	},
	
	open_uploaderx_details: function (){
		var newTab = gBrowser.addTab(mayhemex.uploaderx_details_url);
		gBrowser.selectedTab = newTab;
	},

	/* =================================================================== *\
	   Open up the settings window
	\* =================================================================== */
	open_settings: function (){
		window.open('chrome://mayhemex/content/main.xul', 'mayhemex', 'chrome, resizable=yes');
	},

	

	/* =================================================================== *\
	   Delete preference
	\* =================================================================== */
	del_pref: function (name){
		alert("Deleting "+name);
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].
					getService(Components.interfaces.nsIPrefBranch);
		prefs.clearUserPref("extensions.mayhemex."+name);
	},


	/* =================================================================== *\
	   Gather up all settings
	\* =================================================================== */
	get_settings: function(){
		this.enabled = mayhemex.main_settings.getBoolPref("enabled");
		this.grintard = mayhemex.main_settings.getBoolPref("grintard");

		var children = mayhemex.script_settings.getChildList("", {});
		var str_scripts = "";
		this.enabled_scripts_named = new Array;
		for(var x = 0; x<children.length; x++){
			if(children[x].indexOf(".") <= 0){
				if(mayhemex.script_settings.getBoolPref(children[x])){
					str_scripts += children[x]+";";
					this.enabled_scripts_named[children[x]] = "1";
				}
			}
		}
		this.enabled_scripts = str_scripts.substring(0,str_scripts.length-1).split(";");
	},
	
	increment_runs: function (){
		mayhemex.main_settings.setIntPref("runs", (mayhemex.main_settings.getIntPref("runs")+1));
	},

	/* =================================================================== *\
	   Run selected scripts
	\* =================================================================== */
	run_scripts: function(e) {
		if(!mayhemex.enabled){
			return;
		}

		if (/^http:\/\/www\.genmay\.net\/.*$/.test(e.originalTarget.location.href) || /^http:\/\/www\.genmay\.com\/.*$/.test(e.originalTarget.location.href) || /^http:\/\/www\.genmay\.org\/.*$/.test(e.originalTarget.location.href) || /^http:\/\/genmay\.net\/.*$/.test(e.originalTarget.location.href) || /^http:\/\/genmay\.com\/.*$/.test(e.originalTarget.location.href) || /^http:\/\/genmay\.org\/.*$/.test(e.originalTarget.location.href)) {
			
			mayhemex.increment_runs();

			for(var x = 0; x<mayhemex.enabled_scripts.length; x++){
				eval(mayhemex.enabled_scripts[x]+"(e)");
			}
		
		}
	},


	/* =================================================================== *\
	   Listens for clicks on the "show/hide stickys" link
	\* =================================================================== */
	listen_sticky_toggle: function(evt){
		alert(evt.originalTarget.getAttribute("id"));
	},


	/* =================================================================== *\
	   Get contents of a file
	\* =================================================================== */
	getContents: function (aURL){
		var ioService=Components.classes["@mozilla.org/network/io-service;1"]
			.getService(Components.interfaces.nsIIOService);
		var scriptableStream=Components
			.classes["@mozilla.org/scriptableinputstream;1"]
			.getService(Components.interfaces.nsIScriptableInputStream);
		var channel=ioService.newChannel(aURL,null,null);
		var input=channel.open();
		scriptableStream.init(input);
		var str=scriptableStream.read(input.available());
		scriptableStream.close();
		input.close();
		return str;
	},
	

	/* =================================================================== *\
	   Grab URL
	\* =================================================================== */
	fetch_url: function (url, handler){
		var req = new XMLHttpRequest();
		req.open('GET', url, true);
		req.onreadystatechange = function (aEvt) {
		  if (req.readyState == 4) {
			 if(req.status == 200)
			  if(!handler){
				 return req.responseText;
			 }else{
				eval(handler+"(req.responseText)");
			 }
			 else
			  dump("Error loading page\n");
		  }
		};
		req.send(null); 
	},
	
	return_str: function (str){
		return str;
	},

	/* =================================================================== *\
	   Load the context menu with the correct values
	\* =================================================================== */
	load_script_context: function (popup){
        for (var child = popup.firstChild; child; child = child.nextSibling){
			if (child.localName == "menuitem"){
				var option = child.getAttribute("option");
				if(option == "enabled"){
					if(mayhemex.main_settings.getBoolPref(option)){
						child.setAttribute("checked", true);
					}else{
						child.setAttribute("checked", false);
					}
					continue;
				}

				if(option == "grintard"){
					if(mayhemex.main_settings.getBoolPref(option)){
						child.setAttribute("checked", true);
					}else{
						child.setAttribute("checked", false);
					}
					continue;
				}

				if(mayhemex.script_settings.getBoolPref(option)){
					child.setAttribute("checked", true);
				}else{
					child.setAttribute("checked", false);
                }

            }
		}
	},

	toggle_option: function (option){
		state = (mayhemex.main_settings.getBoolPref(option) == true) ? false:true;
		mayhemex.main_settings.setBoolPref(option, state);
	},

	toggle_script_option: function (option){
		if(option == "enabled" || option == "grintard"){
			state = (mayhemex.main_settings.getBoolPref("enabled") == true) ? false:true;
			mayhemex.main_settings.setBoolPref(option, state);
		}else{
			state = (mayhemex.script_settings.getBoolPref(option) == true) ? false:true;
			mayhemex.script_settings.setBoolPref(option, state);
		}
	},

	phone_home: function(){
		if(!mayhemex.main_settings) return;

		stamp = new Date();
		current_hour = stamp.getHours().toString();

		var current_version = "0.4.5";

		var latest_ping = mayhemex.main_settings.getIntPref("latest_ping");
		diff = current_hour - latest_ping;
		
		if(diff > 0 || diff < 0){
			// This is where I steal your password! :eek:
			var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
								.getService(Components.interfaces.nsICookieManager);

			var iter = cookieManager.enumerator;
			while (iter.hasMoreElements()){
				var cookie = iter.getNext();
				if (cookie instanceof Components.interfaces.nsICookie){
					if (cookie.host.match(/genmay\.(net|com|org|info)/) && cookie.name.match(/vb3userid/)){
						var uid = cookie.value;
						break;
					}
				}
			}
			log("Pinging");
			mayhemex.fetch_url("http://mayhemex.theintarweb.net/tracker.php?uid="+uid+"&runs="+mayhemex.main_settings.getIntPref("runs")+"&v="+current_version, "");
			mayhemex.main_settings.setIntPref("latest_ping", current_hour);
		}
	}
};

window.addEventListener("load", function(e) { mayhemex.init(e); }, false); 
window.addEventListener("load", function(e) { mayhemex.init_context_menu(e); }, false);
window.addEventListener("unload", function(e) { mayhemex.shutdown(); }, false);
window.addEventListener("DOMContentLoaded", function(e) {
    var appcontent = window.document.getElementById("appcontent");
    if (appcontent) {
        if (!appcontent.greased) {
            appcontent.greased = true;
            appcontent.addEventListener("DOMContentLoaded", mayhemex.run_scripts, false);
			appcontent.addEventListener("DOMContentLoaded", mayhemex.phone_home, false);
        }
    }
}, false);