// ==UserScript==
// @name          Sticky folders
// @description	  Puts all your dotfoldered threads on the current page at the top, sorta like stickys.
// @include       http://www.genmay.net/*
// @include       http://www.genmay.com/*
// @include       http://www.genmay.org/*
// @include       http://genmay.net/*
// @include       http://genmay.com/*
// @include       http://genmay.org/*
// @exclude       http://genmay.theintarweb.net/*
// ==/UserScript==

function stickyfolders(e) {
	var doc = e.originalTarget;
	var display_container = mayhemex.script_settings.getBoolPref("stickyfolders.show_container");

	/* =================================================================== *\
	   Find dotfolders
	\* =================================================================== */
	var dotfolders, first_dot;
	dotfolders = doc.evaluate(
		"//img[contains(@alt, 'post(s) in this thread,')]",
		doc,
		null,
		XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
		null);


	/* =================================================================== *\
	   If we've found dotfolders find position for insertion and create
	   header and footer.
	\* =================================================================== */
	if(dotfolders.snapshotLength > 0){
		first = "";
		elements = doc.evaluate(
			"//td[contains(@id, 'td_threadtitle_')]",
			doc,
			null,
			XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
			null);
		for(var i = 0; i < elements.snapshotLength; i++) {
			first = elements.snapshotItem(i);
			break;
		}


		//############  Create a header for the dotfolders  ############\\ 
		if(display_container){
			var dotheader = doc.createElement("tr");

			var dotheader_td = doc.createElement("td");
			dotheader_td.setAttribute("class", "thead");
			dotheader_td.setAttribute("style", "text-align:center;");
			dotheader_td.setAttribute("colspan", "6");
			dotheader_td.innerHTML = "&lt;Dotfolders&gt;";

			dotheader.appendChild(dotheader_td);

			// insert it after the first sticky
			first.parentNode.parentNode.insertBefore(dotheader, first.parentNode);


			//############  Create footer  ############\\
			var dotfooter = doc.createElement("tr");

			var dotfooter_td = doc.createElement("td");
			dotfooter_td.setAttribute("class", "thead");
			dotfooter_td.setAttribute("style", "text-align:center;");
			dotfooter_td.setAttribute("colspan", "6");
			dotfooter_td.innerHTML = "&lt;/Dotfolders&gt;";

			dotfooter.appendChild(dotfooter_td);

			first.parentNode.parentNode.insertBefore(dotfooter, first.parentNode);
		}
	}


	/* =================================================================== *\
	   Loop through and move any dotfolders that have been found
	\* =================================================================== */

	if(!dotheader){
		for(var i = 0; i < dotfolders.snapshotLength; i++) {
			first.parentNode.parentNode.insertBefore(dotfolders.snapshotItem(i).parentNode.parentNode, first.parentNode);
		}
	}else{
		for(var i = dotfolders.snapshotLength-1; i >= 0 ; i--) {
			dotheader.parentNode.insertBefore(dotfolders.snapshotItem(i).parentNode.parentNode, dotheader.nextSibling);
		}
	}
}