// Threadcrumbs
function query_values(query) {
	var arr_parms = new Array();
	var parms = query.split('&');

	for (var i=0; i<parms.length; i++) {
		var pos = parms[i].indexOf('=');
		if (pos > 0) {
			var key = parms[i].substring(0,pos);
			var val = parms[i].substring(pos+1);
			arr_parms[key] = val;
		}
	}
	return arr_parms;
}


function threadcrumbs(e){
	var doc = e.originalTarget;
	
	var color1 = mayhemex.script_settings.getCharPref("threadcrumbs.color1");
	var color2 = mayhemex.script_settings.getCharPref("threadcrumbs.color2");
	var noarrow = mayhemex.script_settings.getBoolPref("threadcrumbs.noarrow");


	var query = doc.location.search.substring(1);
	var arr_parms = query_values(query);
	var current_thread = arr_parms["t"];
	var current_page = parseInt(arr_parms["page"]);
	if(!current_page){current_page = 1;}

	var viewing_thread = ((doc.location.toString().indexOf("showthread") > 0) ? true:false);
	var viewing_index = ((doc.location.toString().indexOf("forumdisplay") > 0) ? true:false);
	

	var threads = mayhemex.script_settings.getCharPref("threadcrumbs.threads");

	threads = unserialize(threads);
	

	/* =================================================================== *\
	   If the thread has been viewed, do the scrolly thing
	\* =================================================================== */

	if(threads[current_thread] != undefined && viewing_thread){
		var thread_info = threads[current_thread].split(";");
		var last_read_post = doc.getElementById("post"+thread_info[0]);

		var head, style;
		head = doc.getElementsByTagName('head')[0];
		if (!head) { return 0; }
		style = doc.createElement('style');
		style.type = 'text/css';
		style.innerHTML = ".meh .alt1 {background:"+color1+" ! important;} .meh .alt2 {background:"+color2+" ! important;}";
		head.appendChild(style);

		posts = doc.evaluate(
			"//table[contains(@id, 'post')]",
			doc,
			null,
			XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,
			null);

		var last_post = 0;
		for(var i = 0; i < posts.snapshotLength; i++) {
			posts.snapshotItem(i).getAttribute("id").match(/post(\d*)/);
			if(RegExp.$1 && RegExp.$1 <= thread_info[0]){
				posts.snapshotItem(i).setAttribute("class", "meh");
			}
		}
		var selectedPosX = 0;
		var selectedPosY = 0;
		while(last_read_post != null){
			selectedPosX += last_read_post.offsetLeft;
			selectedPosY += last_read_post.offsetTop;
			last_read_post = last_read_post.offsetParent;
		}

		 content.window.scrollTo(selectedPosX,selectedPosY+60);
	}


	/* =================================================================== *\
	   Add (update) threadcrumb to the list
	\* =================================================================== */
	if(viewing_thread){
		posts = doc.evaluate(
			"//table[contains(@id, 'post')]",
			doc,
			null,
			XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
			null);
		var last_post = posts.snapshotItem(posts.snapshotLength-2).getAttribute("id").replace("post", "");
		
		var d = new Date();
		threads[current_thread] = last_post+";"+current_page+";"+d.getTime();

		// Clean out old entries
		threads.forEach(prune_threads);

		threads = serialize(threads);
		mayhemex.script_settings.setCharPref("threadcrumbs.threads", threads);
	}



	/* =================================================================== *\
	   Add custom "last read"-arrows
	\* =================================================================== */
	if(viewing_index){
		thread = doc.evaluate(
			"//a[contains(@id, 'thread_title_')]",
			doc,
			null,
			XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,
			null);
		for(var i = 0; i < thread.snapshotLength; i++) {
			thread_id = thread.snapshotItem(i).getAttribute("id").replace("thread_title_", "");
			if(threads[thread_id] != undefined){
				thread_info = threads[thread_id].split(";");
				if(noarrow){
					thread.snapshotItem(i).setAttribute("href", "showthread.php?t="+thread_id+"&page="+thread_info[1]);
				}else{
					thread.snapshotItem(i).parentNode.innerHTML = "<a href=\"showthread.php?t="+thread_id+"&page="+thread_info[1]+"\"><img src=\"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAkAAAAKCAYAAABmBXS%2BAAAABGdBTUEAAK%2FINwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAABzSURBVHjaYnxz8SIDCNzbuPE%2FAxpQ8vdnBNEsMIHfnz8z4AJwRb8%2BfSKs6PeXL0QowmMd40p39%2F8MBAAjyHfrCwpwKgycMIGRERYE8zIzMRQmTZ%2FOCDcJBnqTkuAKi%2BfNY4SxmZB1giQ%2B%2FvqFogAEAAIMAAIKLk65MeUxAAAAAElFTkSuQmCC\" class=\"inlineimg\" style=\"border:0px;\" /></a>" + thread.snapshotItem(i).parentNode.innerHTML;
				}
			}
		}
	}

	return 0;
}

function prune_threads(element, index, array) {
	var time = new Date();
	var now = time.getTime();
    var values = element.split(";");
	
	var prune_limit = mayhemex.script_settings.getIntPref("threadcrumbs.prune_limit");

	if(values[2] < (now-(1000*60*60*24*prune_limit))){
		//log(element+" is less than... whatever. BALEET!");
		delete(array[index]);
	}
}
